﻿Public Class ConsoleGeoCalc

    Public Function Calculate(ByVal input As String) As String

        _input = input
        _index = 0

        Dim ans As GeoCalc.TS
        ans = ParseInput()
        Return ans.ToString
    End Function

    Public Function CalculateAdvance(ByVal input As String) As String

        _input = input
        _index = 0

        Dim ans As GeoCalc.TS
        ans = ParseInput().Reduce()
        Return ans.ToString2
    End Function

    Public Function CalculateAdvance2(ByVal input As String) As String

        _input = input
        _index = 0

        Dim ans As GeoCalc.TS
        ans = ParseInput().Reduce().Reduce2()
        Return ans.ToString2
    End Function

    ' 解析開始
    Public Function ParseInput() As GeoCalc.TS
        PassSpace()
        Return Parse7()
    End Function

    ' +の項の処理
    Public Function Parse7() As GeoCalc.TS

        Dim ts1 As GeoCalc.TS, ts2 As GeoCalc.TS
        ts1 = Parse6()
        While True
            PassSpace()
            If Not IsEndInput() AndAlso _input(_index) = "+" Then
                ' +の処理をする
                _index = _index + 1
                ts2 = Parse6()
                ts1 = ts1.OrTS(ts2)
            Else
                Exit While
            End If
        End While

        Return ts1

    End Function

    ' *の項の処理
    Public Function Parse6() As GeoCalc.TS

        Dim ts1 As GeoCalc.TS, ts2 As GeoCalc.TS
        ts1 = Parse5()
        While True
            PassSpace()
            If Not IsEndInput() AndAlso _input(_index) = "*" Then
                _index = _index + 1
                ts2 = Parse5()
                ts1 = ts1.AndTS(ts2)
            Else
                Exit While
            End If
        End While

        Return ts1
    End Function

    ' "'"の処理
    Public Function Parse5() As GeoCalc.TS

        Dim ts1 As GeoCalc.TS
        ts1 = Parse4()

        PassSpace()
        If Not IsEndInput() AndAlso _input(_index) = "'" Then
            _index = _index + 1
            ts1 = ts1.NegTS()
        End If
        Return ts1
    End Function

    ' {}か一つの数の処理
    Public Function Parse4() As GeoCalc.TS

        PassSpace()
        If Not IsEndInput() AndAlso _input(_index) = "{" Then
            ' ()の処理
            _index = _index + 1
            Dim ret As GeoCalc.TS
            ret = Parse7()
            PassSpace()
            If IsEndInput() OrElse _input(_index) <> "}" Then
                Throw New ApplicationException("{}が正しく閉じていません")
            End If
            _index = _index + 1
            Return ret
        Else
            ' 1つの数のみ
            Return New GeoCalc.TS(Parse3())
        End If

    End Function

    ' 項の羅列を読む
    Public Function Parse3() As GeoCalc.T

        If IsEndInput() OrElse _input(_index) <> "(" Then
            Throw New ApplicationException("(がありません")
        End If

        _index = _index + 1

        Dim ret As Long()
        ReDim ret(-1)
        While True
            Dim val As Long
            val = Parse2()

            ReDim Preserve ret(ret.Length)
            ret(ret.Length - 1) = val

            PassSpace()
            If IsEndInput() OrElse _input(_index) <> "," Then
                Exit While
            End If
            _index = _index + 1
        End While


        If IsEndInput() OrElse _input(_index) <> ")" Then
            Throw New ApplicationException(")がありません")
        End If

        _index = _index + 1

        Return New GeoCalc.T(ret)
    End Function

    ' 3ケタの2進数を読み込む
    Public Function Parse2() As Long

        PassSpace()

        Dim i1 As Long, i2 As Long, i3 As Long
        i1 = Parse1()
        i2 = Parse1()
        i3 = Parse1()
        Return i1 * 4 + i2 * 2 + i3
    End Function

    ' 2進数一けたを読む
    Public Function Parse1() As Long
        If IsEndInput() Then
            Throw New ApplicationException("項の数字が欠けています")
        End If

        _index = _index + 1
        If _input(_index - 1) = "0" Then
            Return 0
        ElseIf _input(_index - 1) = "1" Then
            Return 1
        Else
            Throw New ApplicationException("数字以外のものが入力されました")
        End If
    End Function

    ' 末尾かのチェック
    Public Function IsEndInput() As Boolean
        Return _index >= _input.Length
    End Function

    ' 空白を読み飛ばす
    Public Sub PassSpace()
        While _index < _input.Length
            If _input(_index) <> " " And Asc(_input(_index)) >= 32 Then ' 制御文字も読み飛ばす
                Return
            End If
            _index = _index + 1
        End While
    End Sub

    Private _input As String    ' 入力
    Private _index As Long      ' 解析している位置
End Class
